import java.awt.geom.Point2D;

public class Arm{
	
	private Arm	parent;
	private double	length,degree,offset = 0;
	
	private CSpace space;
	
	public Arm(){
		this(new Arm(null,0,0));
	}
	
	public Arm(Arm parent){
		this(parent,10);
	}
	
	public Arm(Arm parent,double length){
		this(parent,length,0);
	}
	
	public Arm(Arm parent,double length,double degree){
		this.parent=parent;
		this.length=length;
		this.degree=degree;
	}
	
	public void setOffset(double degree){
		offset = degree;
	}
	
	public synchronized void setDegree(double degree){
		this.degree = degree;
		
		space.repaint();
	}
	
	public synchronized double getDegree(){
		return degree;
	}
	
	public double getLength(){
		return length;
	}

	public synchronized Point2D.Double getPoint(){
		double x=0,y=0;
		Point2D.Double pd=new Point2D.Double();
		double degr=degree+offset;
		if(parent==null){
			pd.x=length*Math.cos(degreeToRadian(degr));
			pd.y=length*Math.sin(degreeToRadian(degr));
		} else{
			Point2D.Double ppd=parent.getPoint();
			pd.x=ppd.x+length*Math.cos(degreeToRadian(degr + parent.getDegree()));
			pd.y=ppd.y+length*Math.sin(degreeToRadian(degr + parent.getDegree()));
		}
		return pd;
	}
	
	public double degreeToRadian(double degree){
		return degree*(Math.PI/180);
	}
	
	public double radianToDegree(double radian){
		return radian*(180/Math.PI);
	}
	
	public void setCSpace(CSpace obj){
		space  = obj;
	}
}
