import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

public class Robot{
	
	private Arm		base,end;
	
	private CSpace	space;
	
	private Obj		objects[];
	
	public Robot(CSpace space,int armcount){
		base=new Arm(null,25,180);
		end=new Arm(base,25,180);
		base.setOffset(270);
		end.setOffset(90);
		
		base.setCSpace(space);
		end.setCSpace(space);
		
		this.space=space;
		
		Arm arms[]={base,end};
		CSpaceVisual visualCSpace=new CSpaceVisual(arms,this);
	}
	
	public void drawRobot(Graphics g){
		g.translate(100,100);
		
		double b,e;
		b=base.getDegree();
		e=end.getDegree();
		
		Point2D.Double[] points={new Point2D.Double(0,0),base.getPoint(),end.getPoint()};
		
		drawPolygon(g,points);
		Rectangle r;
		if(objects!=null) for(int i=0; i<objects.length; i++){
			r=objects[i].get();
			g.fillRect(r.x,-1*(r.y+r.height),r.width,r.height);
		}
	}
	
	public void drawPolygon(Graphics g,Point2D.Double[] points){
		int[ ] xpoints,ypoints;
		xpoints=new int[points.length];
		ypoints=new int[points.length];
		
		for(int i=0; i<points.length; i++){
			xpoints[i]=(int) points[i].x;
			ypoints[i]=-1*((int) points[i].y);
		}
		
		g.drawPolyline(xpoints,ypoints,points.length);
	}
	
	public void setObjects(Obj objects[]){
		this.objects=objects;
	}
	
	public Obj[ ] getObjects(){
		return objects;
	}
}
